	SUBROUTINE KMEAN(JDA,NPPM,NM)
c  Purpose:
c   - Computes mean of nppm 1-minute values
c   - Computes daily mean from nppm mean
c   - Rejects nppm mean values
c      - If mean value is not within confidence limits for means the
c        mean is deleted.  Mean values are not checked against the
c        lower confidence limit on quiet days.  The confidence limits
c        are generated by program SELMVS.
c      - If the range of the nppm 1-minute values exceeds the range
c        limits the value is deleted.  The range limits are generated
c        by program SELMVS.
c      - if the number good 1-minute values is less than nppm/2, the
c        mean value is deleted.
c   - Rejects daily mean if the number of nppm mean values is less than
c     nm/2.  The value is replaced by the monthly mean obtained using
c     program SELMVS.
C
	INTEGER*2 E,H,X,NPPM,NM,ICNT,MAXH,MINH,I,II,ITD,NSH,JDA,IH
	INTEGER*4 JV,IDEL
	REAL*4 SH
      DIMENSION X(1440,2),IDEL(12)
C
      INTEGER*2 IX
      COMMON/ABLE/IX(5762)
C
	INTEGER*2 MHV,IDM
	REAL*4 XD
      COMMON/BAKER/MHV(360,2),IDM(3,2),XD
C
      CHARACTER*2 ID
	INTEGER*2 MHI,MLO,RNG,MENDS,IDA,MQD,TH,VH
	REAL*4 DX,SV,SND,AV,SE,MODE,MEDIAN
	COMMON/DOG/MHI(2),MLO(2),ID,DX,SV(2),SND(2,2),RNG(2),
     *MENDS(2),IDA(10),MQD(10),AV(2,2),SE(2,2),MODE(2,2),
     *MEDIAN(2,2),TH(10),VH(10)
C
	CHARACTER*1 DEBUG
	INTEGER*2 IKM,IXY,IGS,ISP,ICSP,IGK
	COMMON/FOX/DEBUG,IKM,IXY,IGS,ISP,ICSP,IGK
c
	CHARACTER*1 SNH
	INTEGER*2 IDT,NBH,NEH,NTR
	REAL*4 SEP,SEPA
	COMMON/HOTEL/IDT,SEP(8,2),SEPA(8,2),SNH,NBH,NEH,NTR(2)
C
	EQUIVALENCE(X(1,1),IX(1))
C
      ICNT=0
      DO 32E=1,2
      I=0
	H=2*NM
      IDM(3,E)=MENDS(E)
      NSD=0
      SD=0.0
	DO 25 K=1,NM
	H=H+1                         !Mean index
      SH=0.0
      NSH=0
      MHV(H,E)=32767
      MAXH=-32767
      MINH=32767
	DO 20L=1,NPPM
      I=I+1					!Minutes of the day counter
      IF(X(I,E).EQ.32767)GOTO 20
C*** FIND MAX AND MIN MINUTE VALUE DURING HOUR INTERVAL
      IF(X(I,E).GT.MAXH)MAXH=X(I,E)
      IF(X(I,E).LT.MINH)MINH=X(I,E)
C*** ACCUMULATE SUM OF MINUTE VALUES
      SH=SH+X(I,E)
      NSH=NSH+1
   20 CONTINUE
	IF(NSH.LT.(NPPM/2))GOTO 25
C*** DELETE MHVS HAVING HOUR RANGE OF MINUTE VALUES > RNG(E)
      ZZ=FLOAT(MAXH)-FLOAT(MINH)
      II=0
      IF(ZZ.LT.32767.)II=MAXH-MINH
	IF(SNH.EQ.'Y' .OR. SNH.EQ.'y')THEN
	  IDT=1                 !Reject range at night
	  IH=H*NPPM/60
	  IF(NBH.GT.NEH)THEN
	    IF(((IH).GE.NBH .AND. (IH).LE.24) .OR.
     *      ((IH).GT.0 .AND. (IH).LE.NEH))THEN
		IF(II.GT.NTR(E))GOTO 24
C            WRITE(*,6666) IH,II,NTR(E)
 6666       FORMAT('  NIGHTIME: ',3I6)
	    END IF
	  ELSE IF((IH).GE.NBH.AND.(IH).LE.NEH)THEN
	    IF(II.GT.NTR(E))GOTO 24
C          WRITE(5,6666) IH,II,NTR(E)
	  END IF
	END IF
	ITD=2                   !Type of reject indicates range limits
	IF(II.GT.RNG(E))GOTO 24
C*** COMPUTE MEAN VALUE FROM SUM OF (NPPM/2) OR MORE MINUTE VALUES.
	ITD=3      !Type of reject indicates confidence limits for mean
      II=SH/NSH
      IF(II.GT.MHI(E))GOTO 24
      DO JJ=1,10
        IF(IDA(JJ).EQ.JDA)GOTO 22	!Is this a quiet day?
      END DO
      IF(II.LT.MLO(E))GOTO 24		!No, then check lower limit
   22 MHV(H,E)=II
      SD=SD+MHV(H,E)
      NSD=NSD+1
      GOTO 25
   24 JV=E*10000+K*10+ITD
      ICNT=ICNT+1
      IDEL(ICNT)=JV
	IF(ICNT.LT.(12))GOTO 25
	WRITE(7,2991)IDEL
 2991 FORMAT(3X,12I6)
      ICNT=0
   25 CONTINUE
C*** COMPUTE DAILY MEAN FROM SUM OF NM/2 OR MORE MEANS
	IF(NSD.GE.(NM/2))IDM(3,E)=SD/NSD
   32 CONTINUE
	IF(ICNT.GT.0)WRITE(7,2991)(IDEL(I),I=1,ICNT)
	IF(DEBUG.EQ.'Y'.AND.IKM.EQ.1)THEN
	  DO I=1,NM
	    J=2*NM+I
	    WRITE(8,2993)I,MHV(J,1),MHV(J,2)
 2993     FORMAT(5X,I4,2I6)
	  ENDDO
	ENDIF
      RETURN
      END
